module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 46);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/registry.js":
/***/ function(module, exports, __webpack_require__) {

"use strict";
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineEnumerableProperties2 = __webpack_require__(15);

var _defineEnumerableProperties3 = _interopRequireDefault(_defineEnumerableProperties2);

var _extends2 = __webpack_require__(4);

var _extends3 = _interopRequireDefault(_extends2);

var _keys = __webpack_require__(0);

var _keys2 = _interopRequireDefault(_keys);

var _getOwnPropertyDescriptors = __webpack_require__(14);

var _getOwnPropertyDescriptors2 = _interopRequireDefault(_getOwnPropertyDescriptors);

var _assign3 = __webpack_require__(13);

var _assign4 = _interopRequireDefault(_assign3);

var _defineProperty = __webpack_require__(2);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

exports.create = create;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defineProperty = _defineProperty2.default,
    assign = _assign4.default,
    getOwnPropertyDescriptors = _getOwnPropertyDescriptors2.default,
    keys = _keys2.default;

var descriptors = getOwnPropertyDescriptors;

/**
 * Takes a host object and attaches a registry object to it. The registry object is
 * an interface that allows you to query for information about its member functions
 * member functions are any function that you want to register by name. they will be memoized
 * lazy loading functions that can be called in the future.
 *
 */
function create() {
  var host = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var propKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'registry';
  var members = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!host) {
    throw 'You must pass a host object';
  }

  var cacheKey = '_' + propKey;

  if (!host[cacheKey]) {
    defineProperty(host, cacheKey, { enumerable: false, value: {} });
  }

  var getters = {};

  var available = keys(descriptors((0, _extends3.default)({}, host[cacheKey], members)));

  available.forEach(function (key) {
    var _assign, _mutatorMap;

    return assign(getters, (_assign = {}, _mutatorMap = {}, _mutatorMap[key] = _mutatorMap[key] || {}, _mutatorMap[key].get = function () {
      return host[cacheKey][key];
    }, (0, _defineEnumerableProperties3.default)(_assign, _mutatorMap), _assign));
  });

  hideGetter(host, propKey, function () {
    keys(descriptors(host[cacheKey])).forEach(function (key) {
      var _assign2, _mutatorMap2;

      return assign(getters, (_assign2 = {}, _mutatorMap2 = {}, _mutatorMap2[key] = _mutatorMap2[key] || {}, _mutatorMap2[key].get = function () {
        return host[cacheKey][key];
      }, (0, _defineEnumerableProperties3.default)(_assign2, _mutatorMap2), _assign2));
    });

    return (0, _extends3.default)({}, getters, {
      get available() {
        return keys(descriptors(host[cacheKey]));
      },
      get register() {
        return function (id, fn) {
          return lazy(host[cacheKey], id, fn);
        };
      }
    });
  });

  return host[propKey];
}

exports.default = create;


function lazy(target, attribute, fn) {
  var enumerable = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  defineProperty(target, attribute, {
    configurable: true,
    enumerable: enumerable,
    get: function get() {
      delete target[attribute];

      if (enumerable) {
        return target[attribute] = typeof fn === 'function' ? fn.call(target) : fn;
      } else {
        var value = typeof fn === 'function' ? fn.call(target) : fn;

        defineProperty(target, attribute, {
          enumerable: enumerable,
          configurable: true,
          value: value
        });

        return value;
      }
    }
  });

  return target;
}

function hideGetter(target, prop, fn) {
  (0, _defineProperty2.default)(target, prop, {
    get: fn.bind(target),
    enumerable: false,
    configurable: true
  });
}

/***/ },

/***/ 0:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/keys");

/***/ },

/***/ 13:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/assign");

/***/ },

/***/ 14:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/get-own-property-descriptors");

/***/ },

/***/ 15:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/defineEnumerableProperties");

/***/ },

/***/ 2:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/define-property");

/***/ },

/***/ 4:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/extends");

/***/ },

/***/ 46:
/***/ function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("./src/registry.js");


/***/ }

/******/ });