module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 35);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/emitter.js":
/***/ function(module, exports, __webpack_require__) {

"use strict";
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.attach = exports.attachEmitter = exports.EventEmitter = undefined;

var _defineProperty = __webpack_require__(2);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _keys = __webpack_require__(0);

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = __webpack_require__(31);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(32);

var _createClass3 = _interopRequireDefault(_createClass2);

var _class, _temp;

exports.attachTo = attachTo;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EventEmitter = exports.EventEmitter = (_temp = _class = function () {
  function EventEmitter() {
    (0, _classCallCheck3.default)(this, EventEmitter);
    this.events = {};
  }

  (0, _createClass3.default)(EventEmitter, [{
    key: 'on',
    value: function on(eventName, fn) {
      if (!this.events[eventName]) {
        this.events[eventName] = [];
      }

      this.events[eventName].push(fn);
    }
  }, {
    key: 'once',
    value: function once(eventName, fn) {
      var self = this;

      this.on(eventName, function once() {
        fn.apply(null, arguments);
        self.off(eventName, once);
      });
    }
  }, {
    key: 'removeAllListeners',
    value: function removeAllListeners() {
      (0, _keys2.default)(this.events).forEach(function (eventName) {
        delete events[eventName];
      });
    }
  }, {
    key: 'off',
    value: function off(eventName, fn) {
      if (!fn) {
        delete this.events[eventName];
        return;
      }

      var index = this.events[eventName].indexOf(fn);
      if (index !== -1) {
        this.events[eventName].splice(index, 1);
        if (this.events[eventName].length === 0) {
          delete this.events[eventName];
        }
      }
    }
  }, {
    key: 'removeListener',
    value: function removeListener(eventName, fn) {
      return this.off(eventName, fn);
    }
  }, {
    key: 'emit',
    value: function emit(eventName) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      if (!this.events[eventName]) return;

      this.events[eventName].forEach(function (fn) {
        fn.apply(null, args);
      });
    }
  }]);
  return EventEmitter;
}(), _class.attachTo = attachTo, _class.attachEmitter = attachTo, _class.attach = attachTo, _temp);
exports.default = EventEmitter;


function hide(target, property, value, configurable) {
  (0, _defineProperty2.default)(target, property, { value: value, configurable: !!configurable, enumerable: false });
  return target;
}

function attachTo(host) {
  var emitter = new EventEmitter();

  hide(host, 'emitter', emitter);
  hide(host, 'on', emitter.on.bind(emitter));
  hide(host, 'addListener', emitter.on.bind(emitter));
  hide(host, 'once', emitter.once.bind(emitter));
  hide(host, 'off', emitter.off.bind(emitter));
  hide(host, 'removeAllListeners', emitter.removeAllListeners.bind(emitter));
  hide(host, 'emit', emitter.emit.bind(emitter));
  hide(host, 'trigger', emitter.emit.bind(emitter));

  return emitter;
}

var attachEmitter = exports.attachEmitter = attachTo;

var attach = exports.attach = attachTo;

/***/ },

/***/ 0:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/keys");

/***/ },

/***/ 2:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/define-property");

/***/ },

/***/ 31:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/classCallCheck");

/***/ },

/***/ 32:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/createClass");

/***/ },

/***/ 35:
/***/ function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("./src/emitter.js");


/***/ }

/******/ });